#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <alloc.h>
#include <string.h>
#include <mem.h>
#include <conio.h>
#include <ctype.h>


// Definitions for print

#define TAB 9
#define END_LINE 0x0A
#define IMM  1
#define DIR  2
#define INDX 3
#define INDY 4
#define EXT  5
#define REL  6
#define MASK 7
#define IMM2 8

unsigned int * label,maxlabel;

void main(int argc, char * argv[])
{
unsigned int findlabel(unsigned int);
char char2asc(char);
FILE *infile, *outfile, *deffile, *update_deffile;
char outname[MAXPATH],defname[MAXPATH];
char drive[MAXDRIVE],dir[MAXDIR];
char file[MAXFILE];char ext[MAXEXT];
char x0,x1,command_operands,nibltmp;
char * tmpptr;
char defstring[256];
char tmpbuf[16];
unsigned int utmp,ci,baseaddr,op_1,op_2,newlabelcount,cd,cl;
unsigned int address=0; // Starting address !!!!
unsigned int filesize,startadr,endadr;




char labeltext[4096][9];
unsigned int databegin[1024],dataend[1024];

char hnibl,lnibl,command_bytes;

char command[16]; // Buffer for decoded command
char operand_1[16]; // First operand
char operand_2[16]; // Second operand
char operand_3[16]; // Third operand
char operand_1_type;


char * line_0[16] =
 { "test","nop","idiv","fdiv","lsrd","asld","tap","tpa",
	 "inx","dex","clv","sev","clc","sec","cli","sei" };
char * line_1[16] =
 { "sba","cba","brset","brclr","bset","bclr","tab","tba",
	 "18","daa","1A","aba","bset","bclr","brset","brclr" };
char * line_2[16] =
 { "bra","brn","bhi","bls","bcc","bcs","bne","beq",
	 "bvc","bvs","bpl","bmi","bge","blt","bgt","ble" };
char * line_3[16] =
 { "tsx","ins","pula","pulb","des","txs","psha","pshb",
	 "pulx","rts","abx","rti","pshx","mul","wai","swi" };
char * line_47[16] =
 { "neg","???","???","com","lsr","???","ror","asr",
	 "asl","rol","dec","???","inc","tst","???","clr" };
char * line_8B[16] =
 { "suba","cmpa","sbca","subd","anda","bita","ldaa","staa",
	 "eora","adca","oraa","adda","cpx","jsr","lds","sts" };
char * line_CF[16] =
 { "subb","cmpb","sbcb","addd","andb","bitb","ldab","stab",
	 "eorb","adcb","orab","addb","ldd","std","ldx","stx" };

//*********************************************************************

if(argc!=2)
 { printf("\n Disassembler for Motorola MC68HC11.");
	 printf("\n (c) Vladimir L. Vasilevskij.\n");
	 printf("\n Usage: disasm [infile]\n");exit(0); }
if((infile=fopen(argv[1],"rb"))==NULL)
 { printf("\n Can't open input file %s.",argv[1]);exit(0); }


fnsplit(argv[1],drive,dir,file,ext);
strcpy(ext,"lst");
fnmerge(outname,drive,dir,file,ext);
if((outfile=fopen(outname,"wt"))==NULL)
 { printf("\n Can't open output file %s.",outname);exit(0); }


strcpy(ext,"def");
fnmerge(defname,drive,dir,file,ext);
if((deffile=fopen(defname,"rt"))==NULL)
 { printf("\n Can't open def file %s.",defname); }
if((update_deffile=fopen(defname,"at"))==NULL)
 { printf("\n Can't open def file %s for append new labels.",defname); }
fprintf(update_deffile,";*******************************************");
fprintf(update_deffile,"\n;**** New labels encountered ***************");
fprintf(update_deffile,"\n;*******************************************");
//*************************************************************
// Analyse deffile;

fseek(infile,0,SEEK_END);
filesize=ftell(infile);
fseek(infile,0,SEEK_SET);


label=malloc(4096*sizeof(unsigned int));
memset(labeltext,0,(4096*9));

cd=0;cl=0;newlabelcount=0;
if(deffile==NULL) goto end_analyse_deffile;
analyse_deffile:
 fgets(defstring,255,deffile);
 if(feof(deffile)) goto end_analyse_deffile;
 if((defstring[0]==0)||(defstring[0]==';')) goto analyse_deffile;
 if(0==memcmp(defstring,"org",3))
	{
	sscanf(defstring+4,"%x",&address);
	startadr=address;
	if((endadr=address+filesize)<=startadr) endadr=0xFFFF;
	goto analyse_deffile;
	}

 if(0==memcmp(defstring,"db",2))
  { sscanf(defstring+3,"%x",&databegin[cd]);
    if((tmpptr=strchr(defstring,'-'))!=NULL)
     { sscanf(tmpptr+1,"%x",&dataend[cd]); }
    else
     { dataend[cd]=databegin[cd]; }
  cd++;
	if(cd>=1024)
   { printf("\n Too many data definitions !\n");fcloseall();exit(0); }

  goto analyse_deffile;
  }
 memset(&labeltext[cl][0],' ',8);
 for(ci=0;ci!=8;ci++)
  {
   if(defstring[ci]!='=')
    { labeltext[cl][ci]=defstring[ci]; }
   else goto label_read;
  }
label_read:
 ci++;
 sscanf(&defstring[ci],"%x",&label[cl]);
 cl++;
 goto analyse_deffile;

end_analyse_deffile: baseaddr=address;maxlabel=cl;
// Command decompiler
fprintf(outfile,"                                      .org $%04x",baseaddr);
decompiler_loop:
x0=fgetc(infile);
command_bytes=1;command_operands=0;
if(feof(infile)) goto pass_complete;
for(ci=0;ci!=cd;ci++)
 {
 if((address>=databegin[ci])&&(address<=dataend[ci]))
  { sprintf(command,".db $%x",x0);goto command_decoded; }
 }
hnibl=(x0&0xF0)>>4;
lnibl=x0&0x0F;

// Very special commands
if(x0==0x6E)
 { command_bytes=2;command_operands=1;
   strcpy(command,"jmp");
   operand_1_type=INDX;
   goto command_decoded; }
if(x0==0x7E)
 { command_bytes=3;command_operands=1;
   strcpy(command,"jmp");
   operand_1_type=EXT;
   goto command_decoded; }
if((x0==0x87)||(x0==0xC7))
 { strcpy(command,"???");goto command_decoded; }
if(x0==0xCD) goto preffix_CD;
if(x0==0x8F)
 { strcpy(command,"xgdx");goto command_decoded; }
if(x0==0xCF)
 { strcpy(command,"stop");goto command_decoded; }
if(x0==0x8D)
 { command_bytes=2;command_operands=1;operand_1_type=REL;
   strcpy(command,"bsr");goto command_decoded; }

// End with special commands;

if(hnibl==0)
 { strcpy(command,line_0[lnibl]);goto command_decoded; }
if(hnibl==1)
 {
 if(lnibl==0x8) goto preffix_18;
 if(lnibl==0xA) goto preffix_1A;
 strcpy(command,line_1[lnibl]);
 if((lnibl<=1)||(lnibl==6)||(lnibl==7)||(lnibl==9)||(lnibl==0xB)) goto command_decoded;
 if((lnibl==4)||(lnibl==5))
  { command_bytes=3;command_operands=2;
    operand_1_type=DIR;
    goto command_decoded; }
 if((lnibl==0xC)||(lnibl==0xD))
  { command_bytes=3;command_operands=2;
    operand_1_type=INDX;
    goto command_decoded; }
 command_bytes=4;command_operands=3;
 if((lnibl==2)||(lnibl==3)) { operand_1_type=DIR;goto command_decoded; }
 operand_1_type=INDX;goto command_decoded;
 } // End with line 1
if(hnibl==2)
 {
 strcpy(command,line_2[lnibl]);
 command_bytes=2;command_operands=1;
 operand_1_type=REL;goto command_decoded;
 } // End with line 2
if(hnibl==3) { strcpy(command,line_3[lnibl]);goto command_decoded; }
 // End with line 3
if(hnibl<=7)
 {
 strcpy(command,line_47[lnibl]);
 if(0==strcmp(command,"???")) goto command_decoded;
 if(hnibl==4) { strcat(command,"a");goto command_decoded; }
 if(hnibl==5) { strcat(command,"b");goto command_decoded; }
 command_operands=1;
 if(hnibl==6)
  { command_bytes=2;operand_1_type=INDX;goto command_decoded; }
 command_bytes=3;operand_1_type=EXT;goto command_decoded;
 } // End with lines 4-7
command_operands=1;
if(hnibl<=0xB) { strcpy(command,line_8B[lnibl]);nibltmp=hnibl; }
else { strcpy(command,line_CF[lnibl]);nibltmp=hnibl-4; }
if(nibltmp==8)
 { command_bytes=2;operand_1_type=IMM;goto pre_decoded; }
if(nibltmp==9)
 { command_bytes=2;operand_1_type=DIR;goto pre_decoded; }
if(nibltmp==0xA)
 { command_bytes=2;operand_1_type=INDX;goto pre_decoded; }
command_bytes=3;operand_1_type=EXT;
pre_decoded:
if(operand_1_type==IMM) // 2-byte immediate operand
  { if((lnibl==3)||(lnibl==0xC)||(lnibl==0xE))
      { command_bytes=3;operand_1_type=IMM2; }
  }
goto command_decoded;
// End with main table
preffix_18:
command_bytes=2;
x1=fgetc(infile);
hnibl=(x1&0xF0)>>4;lnibl=x1&0xF;
if(x1==0x8)  { strcpy(command,"iny");goto command_decoded;  }
if(x1==0x9)  { strcpy(command,"dey");goto command_decoded;  }
if(x1==0x30) { strcpy(command,"tsy");goto command_decoded;  }
if(x1==0x35) { strcpy(command,"tys");goto command_decoded;  }
if(x1==0x38) { strcpy(command,"puly");goto command_decoded; }
if(x1==0x3A) { strcpy(command,"aby");goto command_decoded;  }
if(x1==0x3C) { strcpy(command,"pshy");goto command_decoded; }
if(x1==0x8F) { strcpy(command,"xgdy");goto command_decoded; }
if(x1==0x8C)
 { strcpy(command,"cpy");
   command_bytes=4;command_operands=1;
   operand_1_type=IMM2;goto command_decoded; }
if(x1==0x9C)
 { strcpy(command,"cpy");
   command_bytes=3;command_operands=1;
   operand_1_type=DIR;goto command_decoded; }
if(x1==0xBC)
 { strcpy(command,"cpy");
   command_bytes=4;command_operands=1;
   operand_1_type=EXT;goto command_decoded; }
if(x1==0xCE)
 { strcpy(command,"ldy");
   command_bytes=4;command_operands=1;
	 operand_1_type=IMM2;goto command_decoded; }
if(x1==0xDE)
 { strcpy(command,"ldy");
   command_bytes=3;command_operands=1;
   operand_1_type=DIR;goto command_decoded; }
if(x1==0xFE)
 { strcpy(command,"ldy");
   command_bytes=4;command_operands=1;
   operand_1_type=EXT;goto command_decoded; }
if(x1==0xDF)
 { strcpy(command,"sty");
   command_bytes=3;command_operands=1;
   operand_1_type=DIR;goto command_decoded; }
if(x1==0xFF)
 { strcpy(command,"sty");
   command_bytes=4;command_operands=1;
   operand_1_type=EXT;goto command_decoded; }
if((x1==0x1C)||(x1==0x1D))
 { strcpy(command,line_1[lnibl]);
   command_operands=2;command_bytes=4;
	 operand_1_type=INDY;
   goto command_decoded; }
if((x1==0x1E)||(x1==0x1F))
 { strcpy(command,line_1[lnibl]);
   command_operands=3;command_bytes=5;
   operand_1_type=INDY;
   goto command_decoded; }
if(hnibl==6)
 { strcpy(command,line_47[lnibl]);
   if(0==strcmp(command,"???")) goto command_decoded;
   command_operands=1;operand_1_type=INDY;command_bytes=3;
   goto command_decoded; }
if(hnibl==0xA)
 { if(lnibl!=0xC) strcpy(command,line_8B[lnibl]);
   else strcpy(command,"cpy");
   command_operands=1;operand_1_type=INDY;command_bytes=3;
   goto command_decoded; }
if(hnibl==0xE)
 { if(lnibl<=0xD) { strcpy(command,line_CF[lnibl]);goto iy_predecode; }
   if(lnibl==0xE) { strcpy(command,"ldy");goto iy_predecode; }
	 strcpy(command,"sty");
  iy_predecode:
   command_operands=1;operand_1_type=INDY;command_bytes=3;
   goto command_decoded; }
strcpy(command,"???");goto command_decoded;
// End of preffix IY table
preffix_1A:
x1=fgetc(infile);command_bytes=2;
if(x1==0x83)
 { strcpy(command,"cpd");
   command_bytes=4;command_operands=1;
   operand_1_type=IMM2;goto command_decoded; }
if(x1==0x93)
 { strcpy(command,"cpd");
   command_bytes=3;command_operands=1;
   operand_1_type=DIR;goto command_decoded; }
if(x1==0xA3)
 { strcpy(command,"cpd");
   command_bytes=3;command_operands=1;
   operand_1_type=INDX;goto command_decoded; }
if(x1==0xB3)
 { strcpy(command,"cpd");
   command_bytes=4;command_operands=1;
   operand_1_type=EXT;goto command_decoded; }
if(x1==0xAC)
 { strcpy(command,"cpy");
   command_bytes=3;command_operands=1;
   operand_1_type=INDX;goto command_decoded; }
if(x1==0xEE)
 { strcpy(command,"ldy");
   command_bytes=3;command_operands=1;
   operand_1_type=INDX;goto command_decoded; }
if(x1==0xEF)
 { strcpy(command,"sty");
   command_bytes=3;command_operands=1;
   operand_1_type=INDX;goto command_decoded; }
strcpy(command,"???");goto command_decoded;
// End with 1A preffix
preffix_CD:
x1=fgetc(infile);command_bytes=2;
if(x1==0xA3)
 { strcpy(command,"cpd");
   command_bytes=3;command_operands=1;
   operand_1_type=INDY;goto command_decoded; }
if(x1==0xAC)
 { strcpy(command,"cpx");
   command_bytes=3;command_operands=1;
   operand_1_type=INDY;goto command_decoded; }
if(x1==0xEE)
 { strcpy(command,"ldx");
   command_bytes=3;command_operands=1;
   operand_1_type=INDY;goto command_decoded; }
if(x1==0xEF)
 { strcpy(command,"stx");
   command_bytes=3;command_operands=1;
   operand_1_type=INDY;goto command_decoded; }
strcpy(command,"???");
// End with CD preffix
command_decoded:
memset(operand_1,0,9);
memset(operand_2,0,9);
memset(operand_3,0,9);
if(command_operands==0) goto no_more_operands;
if(operand_1_type==REL)
 { utmp=fgetc(infile);
	 if(utmp<128) op_1=address+utmp+2;
	 else op_1=address-(256-utmp)+2;
	 goto if_operand_1_label; }
if((operand_1_type==IMM)||(operand_1_type==DIR)||(operand_1_type==INDX)||(operand_1_type==INDY))
 { op_1=fgetc(infile);goto if_operand_1_label; }
if((operand_1_type==IMM2)||(operand_1_type==EXT))
 { op_1=256*fgetc(infile)+fgetc(infile); }

if_operand_1_label:
sprintf(operand_1," ");
if((operand_1_type==IMM)||(operand_1_type==IMM2)) sprintf(operand_1,"#");

if((op_1<startadr)||(op_1>endadr))
 {
 sprintf(tmpbuf,"$%x",op_1);
 strcat(operand_1,tmpbuf);
 goto end_op_1_1;
 }

if((ci=findlabel(op_1))!=maxlabel)
 {
 strcat(operand_1,&labeltext[ci][0]); // Known label
 }
else
 {
 label[maxlabel]=op_1;
 sprintf(&labeltext[maxlabel][0],"L__%05u",newlabelcount);
 strcat(operand_1,&labeltext[maxlabel][0]);
 maxlabel++;
 fprintf(update_deffile,"\nL__%05u=%04x",newlabelcount,op_1);
 newlabelcount++;
 }
end_op_1_1:
if(operand_1_type==INDX) strcat(operand_1,",X");
if(operand_1_type==INDY) strcat(operand_1,",Y");
end_op_1:
if(command_operands==1) goto no_more_operands;

// Operand 2 can be byte mask only !  - masks no labeled.

op_2=fgetc(infile);
sprintf(operand_2,"$%02x",op_2);
if(command_operands==2) goto no_more_operands;

// Operand 3 can be rel offset only !

utmp=fgetc(infile);
if(utmp<128) op_1=address+utmp+command_bytes;
else op_1=address-(256-utmp)+command_bytes;

if((op_1<startadr)||(op_1>endadr))
 {
 sprintf(tmpbuf,"$%x",op_1);
 strcat(operand_3,tmpbuf);
 goto no_more_operands;
 }


if((ci=findlabel(op_1))!=maxlabel)
 {
 sprintf(operand_3,"%s",&labeltext[ci][0]); // Known label
 }
else
 {
 label[maxlabel]=op_1;
 sprintf(&labeltext[maxlabel][0],"L__%05u",newlabelcount);
 sprintf(operand_3,"%s",&labeltext[maxlabel][0]);
 maxlabel++;
 fprintf(update_deffile,"\nL__%05u=%04x",newlabelcount,op_1);
 newlabelcount++;
 }
no_more_operands:
fprintf(outfile,"\n%04X ",address);
fseek(infile,-command_bytes,SEEK_CUR);
for(ci=0;ci!=command_bytes;ci++) fprintf(outfile," %02X",fgetc(infile));
for(ci=0;ci!=(15-(command_bytes*3));ci++) fputc(' ',outfile);
fseek(infile,-command_bytes,SEEK_CUR);
fprintf(outfile,"  ");
for(ci=0;ci!=command_bytes;ci++)
 { fprintf(outfile," %c",char2asc(fgetc(infile))); }
for(ci=0;ci!=(10-(command_bytes*2));ci++) fputc(' ',outfile);


fprintf(outfile," . ");
if((ci=findlabel(address))!=maxlabel)
 {
 fprintf(outfile,"%s",&labeltext[ci][0]);
 }
else
 {
 fprintf(outfile,"        ");
 }
fprintf(outfile," %s",command);
if(command_operands>=1) fprintf(outfile," %s",operand_1);
if(command_operands>=2) fprintf(outfile," %s",operand_2);
if(command_operands>=3) fprintf(outfile," %s",operand_3);
address+=command_bytes;
goto decompiler_loop;

pass_complete: printf("\n Done.\n");
fcloseall();
exit(0);
}
 // End of main
unsigned int findlabel(unsigned int x)
{
unsigned int i;
for(i=0;i!=maxlabel;i++) if(x==label[i]) return i;
return maxlabel;
}
char char2asc(char x)
{
if((x>=0x20)&&(x<128)) return x;
return '?';
}